C This is a collection of PostScript output routines

C Written by Michael W. Deem 9 July 1991.

C This routine sets up the page.
      subroutine PSINIT(unit)

      implicit none

      integer*2 unit

      integer*4 itmp
      real*4 writex, writey
      common /pscursor/ writex, writey

      integer*4 npages, nfonts, MAXFONTS
      parameter (MAXFONTS = 100)
      character*80 fonts(MAXFONTS)
      common /pssave/ npages, nfonts, fonts

C PostScript prolog
      write(unit,100) '%!PS-Adobe-2.0'
      write(unit,100) '%%DocumentFonts: (atend)'
      write(unit,100) '%%Title: ZEFSA3D OUTPUT'
      write(unit,100) '%%Creator: Michael W. Deem'
      write(unit,100) '%%For: Michael W. Deem'
      write(unit,100) '%%Pages: (atend)'
      write(unit,100) '%%EndComments'
      write(unit,100) '/mv /moveto load def'
      write(unit,100) '/ln /lineto load def'
      write(unit,100) '/st /stroke load def'
      write(unit,100) '/cl /closepath load def'
      itmp = 0
      call PSLINEJ(unit, itmp)
      itmp = 2
      call PSLINEC(unit, itmp)
      call PSLINEW(unit, 0.1)
      call PSGRAY(unit, 0.0)
      write(unit,100) '%%EndProlog'
      writex = 1.0
      writey = 10.0
      npages = 0
      nfonts = 0
      return
100   format(A)
      end


C This routine writes the trailer to unit
      subroutine PSEND(unit)

      implicit none

      integer*2 unit

      integer*4 npages, nfonts, MAXFONTS
      parameter (MAXFONTS = 100)
      character*80 fonts(MAXFONTS)
      common /pssave/ npages, nfonts, fonts

      integer*4 i

      write(unit,100) '%%Trailer'
      if (nfonts .ne. 0) write(unit,110) '%%DocumentFonts: ',
     |                 fonts(1)(1:index(fonts(1), ' '))
      do 10 i = 2, nfonts
10      write(unit,110) '%%+',
     |                 fonts(i)(1:index(fonts(i), ' '))
      write(unit,120) '%%Pages: ',npages
      return
100   format(A)
110   format(2A)
120   format(A, I8)
      end


C This routine saves the VM state and starts a new page
      subroutine PSPAGE(unit)

      implicit none

      integer*2 unit

      integer*4 npages, nfonts, MAXFONTS
      parameter (MAXFONTS = 100)
      character*80 fonts(MAXFONTS)
      common /pssave/ npages, nfonts, fonts

      npages = npages + 1
      write(unit, 100) '%%Page: ',npages, npages
      write(unit, 100) 'save'
      return
100   format(A, 2I8)
110   format(A)
      end


C This routine finishes the page, prints it, and restores the VM state
      subroutine PSSHOWP(unit)

      implicit none

      integer*2 unit

      write(unit,100) 'showpage'
      write(unit,100) 'restore'
      return
100   format(A)
      end


C This routine writes newpath to unit
      subroutine PSNEW(unit)

      implicit none

      integer*2 unit

      write(unit,100) 'newpath'
      return
100   format(A)
      end


C This routine writes closepath to unit
      subroutine PSCLOSE(unit)

      implicit none

      integer*2 unit

      write(unit,100) 'cl'
      return
100   format(A)
      end


C This routine writes stroke to unit
      subroutine PSSTROKE(unit)

      implicit none

      integer*2 unit

      write(unit,100) 'st'
      return
100   format(A)
      end


C This routine writes to unit a moveto command
C These coordinates should be in inches
      subroutine PSMOVE(unit, x, y)

      implicit none

      integer*2 unit
      real*4 x, y

      write(unit, 100) 72.0*x, 72.0*y, 'mv'
      return
100   format(2F8.3, ' ', A)
      end


C This routine writes to unit a lineto command
C These coordinates should be in inches
      subroutine PSLINE(unit, x, y)

      implicit none

      integer*2 unit
      real*4 x, y

      write(unit, 100) 72.0*x, 72.0*y, 'ln'
      return
100   format(2F8.3, ' ', A)
      end


C This routine changes the writex, writey text cursor cooridnates
C These coordinates should be in inches
      subroutine PSXY(x,y)

      implicit none

      real*4 x, y

      real*4 writex, writey
      common /pscursor/ writex, writey

      writex = x
      writey = y
      return
      end


C This routine writes a line of text to unit, updating the cursor
      subroutine PSWRITE(unit, string)

      implicit none

      integer*2 unit
      character*(*) string

      real*4 writex, writey
      common /pscursor/ writex, writey

      integer*2 i
      real*4 xold

C find first non-blank character at right end of string
      do 10 i = len(string), 1, -1
        if (string(i:i) .ne. ' ') goto 20
10      continue
      i = 1
20    call PSMOVE(unit, writex, writey)
      write(unit, 100) string(1:i)
      writey = writey - 1.0/6.0
      return
100   format('(', A, ') show')
      end


C This routine writes the newfont commands to unit
C If nfonts exceeds MAXFONTS, DocumentFonts will be inacurrate
      subroutine PSFONT(unit, font, size)

      implicit none

      integer*2 unit
      character*(*) font
      real*4 size

      integer*4 npages, nfonts, MAXFONTS
      parameter (MAXFONTS = 100)
      character*80 fonts(MAXFONTS)
      common /pssave/ npages, nfonts, fonts

      integer*4 i

      write(unit,100) '/', font, ' findfont'
      write(unit,110) size, ' scalefont setfont'
C add font to fonts listing if it is new
      do 10 i = 1, nfonts
        if (font .eq. fonts(i)) return
10      continue
      nfonts = min(nfonts + 1, MAXFONTS)
      fonts(nfonts) = font
      return
100   format(A,A,A)
110   format(F10.5, A)
      end


C This routine changes the gray-scale level
      subroutine PSGRAY(unit, gray)

      implicit none

      integer*2 unit
      real*4 gray

      write(unit,100) gray, ' setgray'
      return
100   format(F10.5, A)
      end


C This routine changes the linejoin setting
      subroutine PSLINEJ(unit, join)

      implicit none

      integer*2 unit
      integer*4 join

      write(unit,100) join, ' setlinejoin'
      return
100   format(I3, A)
      end


C This routine changes the linecap setting
      subroutine PSLINEC(unit, cap)

      implicit none

      integer*2 unit
      integer*4 cap

      write(unit,100) cap, ' setlinecap'
      return
100   format(I3, A)
      end


C This routine writes setlinewidth to unit
      subroutine PSLINEW(unit, width)

      implicit none

      integer*2 unit
      real*4 width

      write(unit,100) width, ' setlinewidth'
      return
100   format(F10.5, A)
      end
