/*
  (C) 1997 Marco Falcioni
  
   chain (linked list) type object. A chain is made of links
   the elements of the structure should only be changed by the 
   methods provided by this interface. Any tampering can and will 
   result in memory leaks.
   

  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html



*/

#ifndef __chain_h
#define __chain_h

#include <stdio.h>
#include "listh.h"


struct Cell;
struct Link;

struct Chain {
  struct Link * head;
  struct Link * tail;
  unsigned long length;
};

P_NEWLIST(Chain)
P_FREELIST(Chain)
P_PRINTLIST(Chain)
P_CLEANLIST(Chain)
P_CATLIST(Chain)
P_TESTLIST(Chain)
P_ADDELEMENT(Chain, Link)
P_ADDELEMENTCHK(Chain, Link)
P_REMOVEELEMENT(Chain, Link) 
P_INLIST(Chain, Link)
P_SORTLIST(Chain, Link)

struct Link * pop_Chain(struct Chain * me);
void oogl_Chain(const struct Chain * Ch, const struct Cell * C, 
		FILE * stream);

#endif
