#include <stdio.h>
#include <stdlib.h>

#include "error.h"
#include "resources.h"
#include "stringlib.h"

#include "functions.h"
#include "positions.h"
#include "grid.h"
#include "chain.h"
#include "link.h"
#include "atoms.h"
#include "params.h"
#include "oogl.h"
#include "misc.h"
#include "verbose.h"

#define OOGL

int main (int argc, char ** argv)
{
  struct Params * P;
  struct Cell * C = 0;
  struct Rad_pattern * RP;
  struct Positions * T = 0;
  struct Sym_group * G = 0;
  struct string_list * options;

  connect_error_stream(stderr, argv[0]);

  options = append_string_to_list(0, "v");

  args_to_resources(argc, argv, options);

  if(extract_global_resource("v")) connect_verbose_stream(stderr, argv[0]);

  read_data(&P, &T, &C, &G, &RP, stdin);

  srand48(P->seed);

  symmetrize_Positions(T,G);
  mod_Positions(T);
  merge_positions(T,P,C);
  mod_Positions(T);

  printf("%ld\n", T->distinct->length);
  
  
  return 0;
  
}

