/*

  (C) 1997 Marco Falcioni
  
  A link IS-A atom, but it has added functionality (linked list)
  creating a new link DOES NOT create a new atom. A link is a temporary
  sovrastructure, defined within a Chain.
  

  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html



*/

#ifndef __link_h
#define __link_h

#include <stdio.h>
struct Atom;

struct Link {
  struct Atom * atom;
  struct Link * prev;
  struct Link * next;
  double key;
};


struct Link * new_Link(struct Atom * A);
void delete_Link(struct Link * This);
void print_Link(const struct Link * This, FILE * stream);
int compare_content_Link(struct Link * const A, struct Link * const B);
struct Link * swap_Link(struct Link * A, struct Link * B);

#endif
