/*

  Marco Falcioni (C) 1997

  oogl methods


  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html



*/

#ifndef __oogl_h
#define __oogl_h

#include <stdio.h>

struct Grid;
struct Cell;
struct Positions;
struct Box;
struct Params;
struct Molecule;

void oogl_bonds(const struct Params * P, 
		const struct Cell * C, 
		const struct Positions * T, 
		const struct Grid * Gr,
		int );

void oogl_all_bonds(const struct Params * P, 
		const struct Cell * C, 
		const struct Positions * T, 
		const struct Grid * Gr,
		int );

void oogl_Grid(const struct Grid * grid, const struct Cell * C);
void oogl_Boxes(const struct Box * B, const struct Cell * C, 
	      const struct Grid * grid);
void oogl_Box(const struct Box * B, const struct Cell * C, 
	      const struct Grid * grid, int a);
void oogl_Positions(const struct Positions * T, 
		    const struct Cell * C, const int print_footer);
void oogl_all_Molecules(const int Nmol,
                        struct Molecule ** M,
                        const struct Cell * C, const int print_header);
void oogl_Molecule(const struct Molecule * T, 
		   const struct Cell * C);
void oogl_Cell(const struct Cell * C, int rec_vec);
void oogl_Init_list(FILE * stream);
void oogl_Finish_list(void);

#endif
