/*

  Marco Falcioni (C) 1997

  read a datafile in XTL form

  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html

*/

#include <stdio.h>
#include <stdlib.h>

#include "error.h"

#include "positions.h"
#include "cell.h"
#include "symmetry.h"
#include "misc.h"
#include "functions.h"
#include "params.h"
#include "rad_pattern.h"
#include "SP_entry.h"
#include "spline.h" 
#include "verbose.h"

void read_XTL( struct Positions * T, struct Cell ** C, struct Sym_group ** G, 
	       FILE * stream)
{
  char line[1024];

  if(stream == 0) {
    push_generic_error("read_data","(nil) arg passed");
    exit_clean();
  }

  push_verbose_message("read_XTL", "reading XTL file");

  get_line(line,sizeof(line), stream);
  get_line(line,sizeof(line), stream);

  (*C) = read_Cell_XTL(stream);

  (*G) = read_Sym_group_XTL( T->n_symmetry, stream);

  read_Positions_XTL(T, stream);
 
  test_Sym_group(*G);

  return;

}
